<?php
$log_file = '/home/wbhkshp/public_html/tacticalDeclines/mids_log.txt';
//$log_file = 'log/mids_log.txt';
$current_time = date('Y-m-d H:i:s');
file_put_contents($log_file, "Mids cron job executed at: $current_time\n", FILE_APPEND);

$timezone = new DateTimeZone('America/New_York');
$datetime = new DateTime('now', $timezone);
$datetime->modify('-12 hours');
// 2 HOURS AGO
$startDate = $datetime->format('n/j/y');
$startTime = $datetime->format('H:i');
// 24 HOURS HENCE
$midBlockTime = $datetime->modify('+24 hours');
$blockedStampStart = (new DateTime('now', $timezone))->getTimestamp();
$blockedStampEnd = $midBlockTime->getTimestamp();
//NOW
$datetimenow = new DateTime('now', $timezone);
$endDate = $datetimenow->format('n/j/y'); //date("Y-m-d H:i:s");
$endTime = $datetimenow->format('H:i');


$loginId = "tac_api_user";
$password = "Yuri123!";
$orderType = "NEW_SALE";
$orderId = "93144044EC";
$resultsPerPage = 100;
$counter = 0;
$transCount= array();
$transListLogging = array();
$sortDir = 0;

$order_query_link = "https://api.checkoutchamp.com/order/query/";
$merchant_query_link = "https://api.checkoutchamp.com/merchant/query/";
$transaction_query_link = "https://api.checkoutchamp.com/transactions/query/";

function get_konnektive_transactions($transaction_query_link, $loginId, $password, $resultsPerPage, $sortDir, $orderType, $startDate, $endDate, $startTime, $endTime)
{
$curl = curl_init();
// Set cURL options
    curl_setopt_array($curl, array(
        //CURLOPT_URL => "$transaction_query_link?loginId=$loginId&password=$password&orderId=$orderId",
        CURLOPT_URL => "$transaction_query_link?loginId=$loginId&password=$password&resultsPerPage=$resultsPerPage&sortDir=$sortDir&orderType=$orderType&startDate=$startDate&endDate=$endDate&startTime=$startTime&endTime=$endTime",
        CURLOPT_RETURNTRANSFER => true, // Return the response as a string instead of outputting it
        CURLOPT_HEADER => false, // Exclude the header from the output
    ));
    $response = curl_exec($curl);
    //file_put_contents('log/cron_log.txt', "dsa: $response \n", FILE_APPEND);
    curl_close($curl);
    $json_data = json_decode($response, true);
    if ($json_data === null) {
        // JSON decoding error occurred
        $error_msg = json_last_error_msg();
        echo "JSON decoding error: $error_msg";
    }
    return $json_data;
}

$blocked = '/home/wbhkshp/public_html/tacticalDeclines/data/blocked.txt';
//$blocked = 'data/blocked.txt';
echo $blocked;

$lines = file($blocked, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
$blockedResult = [];
foreach ($lines as $line) {
    // Split the line into the key and value using ':' as a delimiter
    list($key, $value) = explode(':', $line);
    
    // Add the key-value pair to the associative array
    if($value <= $blockedStampStart){
        $blockedResult[(int)$key] = $value;
    }
}

// Output the resulting array
echo "<pre>";
print_r($blockedResult);
echo "</pre>";
//file_put_contents($blocked, $blockedResult."\n");
echo "<br>"."start: ".$blockedStampStart."<br>";
echo "end: ".$blockedStampEnd;

$merchant_response = get_konnektive_transactions($transaction_query_link, $loginId, $password, $resultsPerPage, $sortDir, $orderType, $startDate, $endDate, $startTime, $endTime);
$merchants = $merchant_response['message']['data'];
$blockedIds;
//echo $merchant_response['message']['totalResults']."\n";
foreach ($merchants as $merchant) {
        if ($merchant['responseType'] !== "SUCCESS" && $merchant['responseType'] !== "SOFT_DECLINE"){
            if (isset($transCount[$merchant['merchantId']])) {
                $transCount[$merchant['merchantId']] += 1;
                $transListLogging[] = $merchant['orderId'];
            } else {
                $transCount[$merchant['merchantId']] = 1;
                $transListLogging[] = $merchant['orderId'];
            }
        }else{
             $transCount[$merchant['merchantId']] = 0;
        } 
        if($transCount[$merchant['merchantId']] == 2 || $transCount[$merchant['merchantId']] > 10){
            if(!array_key_exists($merchant['merchantId'], $blockedResult)){
                $blockedIds = $blockedIds."\n".$merchant['merchantId'].":".$blockedStampEnd;
                $blockedResult[(int)$merchant['merchantId']] = $blockedStampEnd;
                $transCount[$merchant['merchantId']] = 0;
                file_put_contents($blocked, $blockedIds);
            }
            if(array_key_exists($merchant['merchantId'], $blockedResult)){
                $transCount[$merchant['merchantId']] = 0;
                continue;
            }
            //notification($merchant['merchantId'], $transCount[$merchant['merchantId']]);
            
            $midsPath2 = '/home/wbhkshp/public_html/tacticalDeclines/data/tacticalGateways.txt';
            //$midsPath2 = 'data/tacticalGateways.txt';
            $logList2 = implode(", ", $transListLogging);
            file_put_contents($midsPath2, "full list: ".$logList2."\n");
            // temporary blocking norifications
            
        }
    // echo "<pre>";
    // print_r($transCount);
    // echo "</pre>";
    // echo $merchant['responseType'];
}
echo "memem: ". $blockedIds;


function notification($mid, $count) {
    $webhook_url = 'https://hooks.slack.com/services/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';
    $message = [
                'text' => "Mid $mid faced $count DECLINEs in a row at TacticalX\n",
                // Optional: You can also specify a username and icon
                'username' => 'Mid Declines Bot',
                'icon_emoji' => ':robot_face:',
            ];
    $message_json = json_encode($message);

    $ch = curl_init($webhook_url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $message_json);
    curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    $response = curl_exec($ch);

    // Check for errors
    if ($response === false) {
        $error = curl_error($ch);
        curl_close($ch);
        die('Curl error: ' . $error);
    }

    // Close the cURL session
    curl_close($ch);

    echo 'Message sent: ' . $message_json;

    $apiToken = "7091971601:AAHrSJPgy4VPqnaenez0n8O4fAzfdza7nTo";
    $url = "https://api.telegram.org/bot$apiToken/getUpdates";

    $channelId = "-4206557619";

    $url = "https://api.telegram.org/bot$apiToken/sendMessage";
    $data = [
                'chat_id' => $channelId,
                'text' => $message['text']
            ];

    // Use cURL to send the message
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    
    // Execute the request
    $responseTg = curl_exec($ch);

    // Check for errors
    if ($responseTg === false) {
    $error = curl_error($ch);
    curl_close($ch);
    die('Curl error: ' . $error);
    }

    // Close the cURL session
    curl_close($ch);

    // Print the response
    echo 'Message sent: ' . $responseTg;
}


// echo "<pre>";
// print_r($orders);
// echo "</pre>";

// $fullListLogging = implode("\n", $orderIdListLogging);

// file_put_contents($log_file, "Full list of checked orders: $fullListLogging\n", FILE_APPEND);
?>